#define FALSE             0
#define TRUE              1

#define CONFIG_FILE       "rpg.cfg"
#define PALETTE_FILE      "game_pal.pal"
#define IMAGE_FILE        "images.rpg"
#define TILES_FILE        "maptiles.art"
#define TOWN_TILES        "towntils.rpg"
#define SPRITE_FILE       "sprites.rpg"
#define MAP_FILE          "main_map.map"
#define INTRO_FILE        "intro.pcx"
#define INTRO2_FILE       "intro2.pcx"
#define START1_FILE       "start1.pcx"
#define START2_FILE       "start2.pcx"
#define ENDING1_FILE      "ending1.pcx"
#define ENDING2_FILE      "ending2.pcx"
#define MENU_FILE         "mainmenu.img"
#define SUBAREA_FILE      "subareas.rpg"
#define BTYPE_FILE        "b_types.rpg"
#define MONSTER_FILE      "monsters.rpg"
#define GAMEDATA_FILE     "gamedata.rpg"
#define MONSTERIMAGE_FILE "m_pics.mpc"
#define BATTLEBACK_FILE   "b_back.mpc"
#define SAVEGAME_FILE     "rpg.sav"
#define SOUND_FILE        "rpg.slb"
#define WARNING_FILE      "warning.pcx"

#define NUMSOUNDS         16
#define XMSREQUIRED       2000      // Should be higher than RPG.SLB size

#define SOUND_CHOICE      0
#define SOUND_SELECT      1
#define SOUND_LEVELUP     2
#define SOUND_WORDBEEP    3
#define SOUND_CHEST       4
#define SOUND_INN         5
#define SOUND_NEWGAME     6
#define SOUND_SUBAREA     7
#define SOUND_BATTLE      8
#define SOUND_DEATH       9
#define SOUND_ENDING      10
#define SOUND_VICTORY     11
#define SOUND_SPELL       12
#define SOUND_P_ATTACK    13
#define SOUND_M_ATTACK    14
#define SOUND_RUN         15

#define MAP_X_SIZE     100
#define MAP_Y_SIZE     100
#define TILE_X         20
#define TILE_Y         20
#define NUM_TILES      128

#define DOWN           0
#define RIGHT          3
#define UP             6
#define LEFT           9

#define WAITING        0
#define MOVING         1

#define NUM_SUB_AREAS  20
#define MAX_EXITS      16
#define MAX_ENTITIES   64

#define NUM_MESSAGES   128
#define MESSAGE_LENGTH 499

#define NUM_BATTLES    32
#define NUM_MONSTERS   128

#define MAX_LEVEL      25

#define NUM_ITEMS      100

#define NUM_USERITEMS  12
#define NUM_WEAPONS    12
#define NUM_HELMETS    12
#define NUM_SHIELDS    12
#define NUM_MAILS      12

#define NUM_SPELLS     8
#define TGT_PLAYER     0
#define TGT_MONSTER    1
#define DAMAGE         0
#define HEALING        1
#define MAKESTATUS     2
#define RMVSTATUS      3

#define STATUS_POISON  (int)1
#define STATUS_FAST    (int)4
#define STATUS_SLOW    (int)8

#define UNEQUIPPED     -1

#define NORMAL         0
#define MENU_QUIT      1
#define PLAYER_DEAD    2
#define ENDING         3
#define MENU_SAVE      4
