#include <dos.h>
#include "mouse.h"

#define MOUSE_INT 0x33

int tval1, tval2, tval3, tval4;

int resetMouse(int *buttons)
{
  asm mov ax, 0x00
  asm int MOUSE_INT
  asm mov tval1, bx
  *buttons = tval1;
  return _AX;
}

void showMouse(void)
{
  asm mov ax, 0x01
  asm int MOUSE_INT
}

void hideMouse(void)
{
  asm mov ax, 0x02
  asm int MOUSE_INT
}

void mouseXYButtons(int *x, int *y, int *buttons)
{
  asm mov ax, 0x03
  asm int MOUSE_INT
  asm mov tval1, bx
  asm mov tval2, cx
  asm mov tval3, dx
  *buttons = tval1;
  *x = tval2;
  *y = tval3;
}

void setMouseXY(int x, int y)
{
  asm mov ax, 0x04
  asm mov cx, x
  asm mov dx, y
  asm int MOUSE_INT
}

void getMouseButtonPressInfo(int button, int *count, int *x, int *y,
                             int *status)
{
  asm mov ax, 0x05
  asm mov bx, button
  asm int MOUSE_INT
  asm mov tval1, ax
  asm mov tval2, bx
  asm mov tval3, cx
  asm mov tval4, dx
  *status = tval1;
  *count = tval2;
  *x = tval3;
  *y = tval4;
}

void getMouseButtonReleaseInfo(int button, int *count, int *x, int *y,
                               int *status)
{
  asm mov ax, 0x06
  asm mov bx, button
  asm int MOUSE_INT
  asm mov tval1, ax
  asm mov tval2, bx
  asm mov tval3, cx
  asm mov tval4, dx
  *status = tval1;
  *count = tval2;
  *x = tval3;
  *y = tval4;
}

void setMouseMinMax(int minX, int minY, int maxX, int maxY)
{
  asm mov ax, 0x07
  asm mov cx, minX
  asm mov dx, maxX
  asm int MOUSE_INT

  asm mov ax, 0x08
  asm mov cx, minY
  asm mov dx, maxY
  asm int MOUSE_INT
}

void setMouseGraphicsCursor(int xHot, int yHot, unsigned char far *bitmap)
{
  asm mov ax, 0x09
  asm mov bx, xHot
  asm mov cx, yHot

  unsigned int bitmapSeg = FP_SEG(bitmap),
               bitmapOff = FP_OFF(bitmap);
  asm mov es, bitmapSeg
  asm mov dx, bitmapOff
  asm int MOUSE_INT
}

void mouseMotionRel(int *x, int *y)
{
  asm mov ax, 0x0B
  asm int MOUSE_INT
  asm mov tval1, cx
  asm mov tval2, dx
  *x = tval1;
  *y = tval2;
}

void mouseSetSensitivity(int x, int y, int dblSpeed)
{
  asm mov ax, 0x1A
  asm mov bx, x
  asm mov cx, y
  asm mov dx, dblSpeed
  asm int MOUSE_INT
}

void setMouseTextCursor(int cursor, int start, int end)
{
  asm mov ax, 0xA0
  asm mov bx, cursor
  asm mov cx, start
  asm mov dx, end
  asm int MOUSE_INT
}

void readMouseMotionCounters(int *x, int *y)
{
  asm mov ax, 0xB0
  asm int MOUSE_INT
  asm mov tval1, cx
  asm mov tval2, dx
  *x = tval1;
  *y = tval2;
}

void setMouseMickeyPixelRatio(int x, int y)
{
  asm mov ax, 0x0F
  asm mov cx, x
  asm mov dx, y
  asm int MOUSE_INT
}
