#include <conio.h>
#include <ctype.h>
#include <stdio.h>

#include "rpg.h"
#include "advinput.h"

gameDataType gamedata;

void loadData(void)
{
  FILE *handle;
  handle = fopen(GAMEDATA_FILE, "rb");
  if (handle == NULL)
    return;
  fread(&gamedata, 1, sizeof(gameDataType), handle);
  fclose(handle);
}

void saveData(void)
{
  FILE *handle;
  handle = fopen(GAMEDATA_FILE, "wb");
  fwrite(&gamedata, 1, sizeof(gameDataType), handle);
  fclose(handle);
}

void levels(void)
{
  int curlevel = 0;

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(GREEN);

    int x;
    for (x = curlevel; x < curlevel + 10; x++)
      cprintf("Level %2d    ->    %8ld exp\n\r",
                     x + 1,       gamedata.levelTable[x]);

    putch('\n');
    cputs("<  Prev       >  Next\n\r"
          "E  Edit Exp. Value\n\r"
          "Q  Return to main menu\n\r");
    putch('\n');

    int lvl;

    switch (toupper(getch()))
    {
      case 0: getch(); break;

      case ',': case '<': if (--curlevel == -1) curlevel = 0; break;
      case '.': case '>': if (++curlevel == MAX_LEVEL - 9)
                curlevel = MAX_LEVEL - 10; break;
      case 'E':
        lvl = getint("Which level: ", 1, MAX_LEVEL) - 1;
        cputs("\n\r");
        gamedata.levelTable[lvl] = getlong("Enter exp. value: ", 0, 99999);
        break;

      case 'Q': done = 1;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

void weapons(void)
{
  int curweapon = 0;

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(RED);
    int x;
    cputs("## Name         Attack   Cost\n\r");
    for (x = curweapon; x < curweapon + 10; x++)
    {
      gotoxy(1,  wherey()); cprintf("%d", x + 1);
      gotoxy(4,  wherey()); cprintf("%s", gamedata.weapons[x].name);
      gotoxy(17, wherey()); cprintf("%d", gamedata.weapons[x].attack);
      gotoxy(26, wherey()); cprintf("%d", gamedata.weapons[x].cost);
      putch('\n');
    }

    gotoxy(1, wherey() + 1);
    cputs("<  Prev     >  Next\n\r"
          "N  Name\n\r"
          "A  Attack\n\r"
          "C  Cost\n\r"
          "Q  Return to main menu\n\r");
    putch('\n');

    int weapon;
    switch (toupper(getch()))
    {
      case '0': getch(); break;

      case ',': case '<': if (--curweapon == -1) curweapon = 0; break;
      case '.': case '>': if (++curweapon == NUM_WEAPONS - 9)
                          curweapon = NUM_WEAPONS - 10; break;
      case 'N':
        weapon = getint("Which weapon: ", 1, NUM_WEAPONS) - 1;
        cputs("\n\r");
        getstring(gamedata.weapons[weapon].name, "Enter name: ", 12);
        break;

      case 'A':
        weapon = getint("Which weapon: ", 1, NUM_WEAPONS) - 1;
        cputs("\n\r");
        gamedata.weapons[weapon].attack = getint("Enter attack: ", 0, 9999);
        break;

      case 'C':
        weapon = getint("Which weapon: ", 1, NUM_WEAPONS) - 1;
        cputs("\n\r");
        gamedata.weapons[weapon].cost = getint("Enter cost: ", 0, 9999);
        break;

      case 'Q': done = 1;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

enum armortype { SHIELDS, HELMETS, MAILS };

void armor(armortype type)
{
  char *armortypestr;
  armorType *armorptr;
  int maxarmor;

  if (type == SHIELDS)
  {
    armortypestr = "shield";
    armorptr     = gamedata.shields;
    maxarmor     = NUM_SHIELDS;
  }
  else
    if (type == HELMETS)
    {
      armortypestr = "helmet";
      armorptr     = gamedata.helmets;
      maxarmor     = NUM_HELMETS;
    }
    else
    {
      armortypestr = "mail";
      armorptr     = gamedata.mails;
      maxarmor     = NUM_MAILS;
    }

  int curarmor = 0;

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(BROWN);

    int x;
    cputs("## Name         Defense  Cost\n\r");
    for (x = curarmor; x < curarmor + 10; x++)
    {
      gotoxy(1,  wherey()); cprintf("%d", x + 1);
      gotoxy(4,  wherey()); cprintf("%s", armorptr[x].name);
      gotoxy(17, wherey()); cprintf("%d", armorptr[x].defense);
      gotoxy(26, wherey()); cprintf("%d", armorptr[x].cost);
      putch('\n');
    }

    gotoxy(1, wherey() + 1);
    cputs("<  Prev     >  Next\n\r"
          "N  Name\n\r"
          "D  Defense\n\r"
          "C  Cost\n\r"
          "Q  Return to main menu\n\r");
    putch('\n');

    int armor;
    switch (toupper(getch()))
    {
      case '0': getch(); break;

      case ',': case '<': if (--curarmor == -1) curarmor = 0; break;
      case '.': case '>': if (++curarmor == maxarmor - 9)
                          curarmor = maxarmor - 10; break;
      case 'N':
        cputs("Which "); cputs(armortypestr);
        armor = getint(": ", 1, maxarmor) - 1;
        cputs("\n\r");
        getstring(armorptr[armor].name, "Enter name: ", 12);
        break;

      case 'D':
        cputs("Which "); cputs(armortypestr);
        armor = getint(": ", 1, maxarmor) - 1;
        cputs("\n\r");
        armorptr[armor].defense = getint("Enter defense: ", 0, 9999);
        break;

      case 'C':
        cputs("Which "); cputs(armortypestr);
        armor = getint(": ", 1, maxarmor) - 1;
        cputs("\n\r");
        armorptr[armor].cost = getint("Enter cost: ", 0, 9999);
        break;

      case 'Q': done = 1;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

void items(void)
{
  int curitem = 0;

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(CYAN);

    int x;
    cputs("## Name          HPup  MPup  Status    Cost\n\r");
    for (x = curitem; x < curitem + 10; x++)
    {
      gotoxy(1,  wherey()); cprintf("%d", x + 1);
      gotoxy(4,  wherey()); cprintf("%s", gamedata.itemData[x].name);
      gotoxy(18, wherey()); cprintf("%d", gamedata.itemData[x].HPup);
      gotoxy(24, wherey()); cprintf("%d", gamedata.itemData[x].MPup);
      gotoxy(30, wherey()); cprintf("%d", gamedata.itemData[x].status);
      gotoxy(40, wherey()); cprintf("%d", gamedata.itemData[x].cost);
      putch('\n');
    }

    gotoxy(1, wherey() + 1);

    cputs("<  Prev       >  Next\n\r"
          "N  Name\n\r"
          "H  HPup\n\r"
          "M  MPup\n\r"
          "S  Status\n\r"
          "C  Cost\n\r"
          "Q  Quit to main menu\n\n\r");
    int itemNum;
    switch (toupper(getch()))
    {
      case 0: getch(); break;

      case '<': case ',': if (--curitem == -1) curitem = 0; break;
      case '>': case '.': if (++curitem == NUM_USERITEMS - 9)
                             curitem = NUM_USERITEMS - 10; break;

      case 'N':
        itemNum = getint("Which item: ", 1, NUM_USERITEMS) - 1;
        cputs("\n\r");
        getstring(gamedata.itemData[itemNum].name, "Enter name: ", 12);
        break;

      case 'H':
        itemNum = getint("Which item: ", 1, NUM_USERITEMS) - 1;
        cputs("\n\r");
        gamedata.itemData[itemNum].HPup = getint("Enter HPup: ", 0, 9999);
        break;

      case 'M':
        itemNum = getint("Which item: ", 1, NUM_USERITEMS) - 1;
        cputs("\n\r");
        gamedata.itemData[itemNum].MPup = getint("Enter MPup: ", 0, 9999);
        break;

      case 'S':
        itemNum = getint("Which item: ", 1, NUM_USERITEMS) - 1;
        cputs("\n\r");
        cputs("(Status) 1 = Poison, 2 = Sleep, 4 = Fast, 8 = Slow\n\r");
        gamedata.itemData[itemNum].status = getint("Enter status: ", 0, 99);
        break;

      case 'C':
        itemNum = getint("Which item: ", 1, NUM_USERITEMS) - 1;
        cputs("\n\r");
        gamedata.itemData[itemNum].cost = getint("Enter cost: ", 0, 9999);
        break;

      case 'Q': done = 1; break;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

void start_items(void)
{
  int curitem = 0;

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(YELLOW);

    int x;
    cputs("##   Type  Number\n\r");
    for (x = curitem; x < curitem + 10; x++)
    {
      gotoxy(1,  wherey()); cprintf("%d", x + 1);
      gotoxy(6,  wherey()); cprintf("%d", gamedata.items[x].type);
      gotoxy(12, wherey()); cprintf("%d", gamedata.items[x].num + 1);
      putch('\n');
    }

    gotoxy(1, wherey() + 1);

    cputs("<  Prev       >  Next\n\r"
          "T  Type\n\r"
          "N  Number\n\r"
          "Q  Quit to main menu\n\n\r");

    int itemNum;
    switch (toupper(getch()))
    {
      case 0: getch(); break;

      case '<': case ',': if (--curitem == -1) curitem = 0; break;
      case '>': case '.': if (++curitem == NUM_ITEMS - 9)
                             curitem = NUM_ITEMS - 10; break;

      case 'T':
        itemNum = getint("Which item: ", 1, NUM_ITEMS) - 1;
        cputs("\n\rNone = 0, Item = 1, Weapon = 2, Shield = 3, Helmet = 4, Mail = 5\n\r");
        gamedata.items[itemNum].type = getint("Enter type: ", 0, 5);
        break;

      case 'N':
        itemNum = getint("Which item: ", 1, NUM_ITEMS) - 1;
        if (gamedata.items[itemNum].type)
        {
          cputs("\n\r");
          gamedata.items[itemNum].num = getint("Enter Number: ", 0, 9999);
        }
        else
        {
          cputs("\n\rYou must enter a type first.\n\r");
          if (getch() == 0) getch();
        }
        break;

      case 'Q': done = 1;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

void spells(void)
{
  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(YELLOW);

    int x;
    cputs("##   Name         Level   MP Cost   Target\n\r");

    textcolor(LIGHTBLUE);
    for (x = 0; x < NUM_SPELLS; x++)
    {
      cprintf("%-2d   %-10s   %-3d     %-2d        %-2d\n\r", x + 1,
              gamedata.spells[x].name,
              gamedata.spells[x].level,
              gamedata.spells[x].cost,
              gamedata.spells[x].target);
    }

    putch('\n');

    textcolor(LIGHTRED);
    cputs("N  Name\n\r"
          "L  Level\n\r"
          "C  MP Cost\n\r"
          "T  Target\n\r"
          "E  Effect\n\r"
          "Q  Quit to main menu\n\n\r");

    int itemNum;
    switch (toupper(getch()))
    {
      case 0: getch(); break;

      case 'N':
        itemNum = getint("Which spell: ", 1, NUM_SPELLS) - 1;
        cputs("\n\r");
        getstring(gamedata.spells[itemNum].name, "Enter name: ", 8);
        break;

      case 'L':
        itemNum = getint("Which spell: ", 1, NUM_SPELLS) - 1;
        cputs("\n\r");
        gamedata.spells[itemNum].level = getint("Enter level: ", 1, MAX_LEVEL);
        break;

      case 'C':
        itemNum = getint("Which spell: ", 1, NUM_SPELLS) - 1;
        cputs("\n\r");
        gamedata.spells[itemNum].cost = getint("Enter cost: ", 0, 9999);
        break;

      case 'T':
        itemNum = getint("Which spell: ", 1, NUM_SPELLS) - 1;
        cputs("\n\r0 = Player, 1 = Monster\n\r");
        gamedata.spells[itemNum].target = getint("Enter target: ", 0, 1);
        break;

      case 'E':
        itemNum = getint("Which spell: ", 1, NUM_SPELLS) - 1;
        cputs("If spell is damage or healing, type in damage factor.\n\r");
        cputs("\n\r0 = Damage, 1 = Healing, 2 = Make Status, 3 = Rmv Status\n\r");
        gamedata.spells[itemNum].effect = getint("Enter effect: ", 0, 3);
        cputs("\n\r");
        cputs("(Status) 1 = Poison, 2 = Sleep, 4 = Fast, 8 = Slow\n\r");
        gamedata.spells[itemNum].factor = getint("Enter factor: ", 0, 9999);
        break;

      case 'Q': done = 1;
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

int main(void)
{
  loadData();

  clrscr();
  textcolor(LIGHTRED);
  cprintf("RPG Data Editor\n\r"
          "Chad Austin 1997\n\r");
  if (getch() == 0) getch();

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(GREEN);
    cputs("RPGEDIT 1.0\n\n\r");
    textcolor(LIGHTBLUE);
    cputs("L  Edit Level Experience Values\n\r"
          "W  Edit Weapon Data\n\r"
          "D  Edit Shield Data\n\r"
          "H  Edit Helmet Data\n\r"
          "M  Edit Mail Data\n\r"
          "I  Edit Item Data\n\r"
          "E  Edit Starting Items\n\r"
          "P  Edit Spells\n\r"
          "S  Save\n\r"
          "Q  Quit\n\r");
    putch('\n');
    switch (toupper(getch()))
    {
      case 0: getch();          break;
      case 'L': levels();       break;
      case 'W': weapons();      break;
      case 'D': armor(SHIELDS); break;
      case 'H': armor(HELMETS); break;
      case 'M': armor(MAILS);   break;
      case 'I': items();        break;
      case 'E': start_items();  break;
      case 'P': spells();       break;
      case 'S': saveData();     break;
      case 'Q': done = 1;
    }
  }

  textcolor(7);
  clrscr();
  return 0;
}
