#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <string.h>
#include <ctype.h>

#include "rpg.h"
#include "advinput.h"

#define pause() if (getch() == 0) getch()

int subarea;

subAreaType sad[NUM_SUB_AREAS];
messageType messages[NUM_MESSAGES];

void loadSubAreaData(void)
{
  FILE *handle;
  handle = fopen(SUBAREA_FILE, "rb");
  if (handle == NULL)
    return;
  fread(sad, sizeof(subAreaType), NUM_SUB_AREAS, handle);

  int x;
  for (x = 0; x < NUM_MESSAGES; x++)
  {
    if (messages[x].txt_read(handle) == NULL)
    {
      int y;
      for (y = 0; y < x; y++)
        messages[x].txt_free();
      cprintf("Error: Could not allocate message memory\n\r");
      exit(1);
    }
  }

  fclose(handle);
}

void saveSubAreaData(void)
{
  // Initialize chest IDs
  // These are used to tell whether the player has opened them or not.
  int id = 1;

  int i;
  for (i = 0; i < NUM_SUB_AREAS; i++)
  {
    int x;
    for (x = 0; x < MAX_ENTITIES; x++)
      if (sad[i].entity[x].type == CHEST)
        sad[i].entity[x].data.chest.id = id++;
  }

  FILE *handle;
  handle = fopen(SUBAREA_FILE, "wb");
  if (handle == NULL)
    return;
  fwrite(sad, sizeof(subAreaType), NUM_SUB_AREAS, handle);

  for (i = 0; i < NUM_MESSAGES; i++)
  {
    messages[i].txt_write(handle);
  }
  fclose(handle);
}

void exitEditor(void)
{
  int done = 0;
  int i;

#define sa sad[subarea]

  while (!done)
  {
    clrscr();
    textcolor(LIGHTRED);
    cprintf("Number of Exits: %d\n\r", sa.numExits);
    for (i = 0; i < sa.numExits; i++)
    {
      cprintf("%-2d  P(%-2d,%-2d)  ", i + 1, sa.exit[i].x, sa.exit[i].y);
      if (sad[subarea].exit[i].type == 0) cputs("Type: Normal"); else
      if (sad[subarea].exit[i].type == 1) cputs("Type: Dirctn"); else
      if (sad[subarea].exit[i].type == 2) cputs("Type: Coord ");

      if (sa.exit[i].type == 1)
      {
        char *dirstr;
        if (sa.exit[i].dir == 0) dirstr = "South";
        if (sa.exit[i].dir == 1) dirstr = "East";
        if (sa.exit[i].dir == 2) dirstr = "North";
        if (sa.exit[i].dir == 3) dirstr = "West";

        cprintf("  Dir: %s", dirstr);

      } else
      if (sa.exit[i].type == 2)
        cprintf("  Coord: (%d, %d)", sa.exit[i].lx, sa.exit[i].ly);
      cputs("\n\r");
    } 
    textcolor(LIGHTBLUE);
    cprintf("\n1. Change number of exits\n\r"
            "2. Edit exit type\n\r"
            "3. Edit coordinate\n\r"
            "4. Edit special value\n\r"
            "Q. Return to main menu\n\n\r");

    switch (toupper(getch()))
    {
      case '1': sad[subarea].numExits = getint("Enter number of exits: ", 0, MAX_EXITS); break;
      case '2':
        if (sad[subarea].numExits)
        {
          int exit;
          exit = getlong("Which exit: ", 1, sa.numExits) - 1;
          cputs("\n\r0 = Normal, 1 = Direction, 2 = Coordinate\n\r");
          sa.exit[exit].type = getint("Enter type: ", 0, 2);
        }
        break;

      case '3':
        if (sad[subarea].numExits)
        {
          int exit;
          exit = getlong("Which exit: ", 1, sad[subarea].numExits) - 1;
          cputs("\n\r");
          sa.exit[exit].x = getint("Enter X coordinate: ", 0, 99);
          cputs("\n\r");
          sa.exit[exit].y = getint("Enter Y coordinate: ", 0, 99);
        }
        break;

      case '4':
        if (sad[subarea].numExits)
        {
          int exit;
          exit = getlong("Which exit: ", 1, sad[subarea].numExits) - 1;
          cputs("\n\r");
          if (sa.exit[exit].type == 1)
          {
            cputs("0 = South, 1 = East, 2 = North, 3 = West\n\r");
            sa.exit[exit].dir = getint("Enter direction: ", 0, 3);
          }

          if (sa.exit[exit].type == 2)
          {
            sa.exit[exit].lx = getint("Enter Coord X Value: ", 0, 99);
            cputs("\n\r");
            sa.exit[exit].ly = getint("Enter Coord Y Value: ", 0, 99);
          }
        }
        break;

      case 'Q': done = 1;
    }
  }
}

#define TYPESTRING "0 = Person, 1 = Chest, 2 = Inn, 3 = Shop, 4 = Boss\n\r"
#define MAX_TYPES 4
#define NUM_TYPES MAX_TYPES

void editEntity(entityType *entity)
{
  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(LIGHTCYAN);
    cprintf("Type: %d\n\r", entity->type);

#define pspriteSet entity->data.person.spriteSet
#define pdirection entity->data.person.direction
#define pmapx      entity->data.person.mapx
#define pmapy      entity->data.person.mapy
#define pdelay     entity->data.person.delay
#define pspeed     entity->data.person.speed
#define pmessage   entity->data.person.message

    if (entity->type == PERSON)
    {
      cprintf("Sprite Set: %d\n\r", pspriteSet);

      char *dirstr = "";

      if (pdirection == 0) dirstr = "Down";
      if (pdirection == 3) dirstr = "Right";
      if (pdirection == 6) dirstr = "Up";
      if (pdirection == 9) dirstr = "Left";

      cprintf("Direction: %s\n\r", dirstr);
      cprintf("Starting Point: (%d, %d)\n\r", pmapx, pmapy);
      cprintf("Delay: %d\n\r", pdelay);
      cprintf("Speed: %d\n\r", pspeed);
      cprintf("Message: (%d) %Fs\n\n\r", pmessage + 1,
                                         messages[pmessage].txt);
      textcolor(LIGHTMAGENTA);
      cputs("T  Change Type\n\r"
            "1  Edit Sprite Set\n\r"
            "2  Edit Direction\n\r"
            "3  Edit Starting Point\n\r"
            "4  Edit Delay\n\r"
            "5  Edit Speed\n\r"
            "6  Edit Message\n\r"
            "Q  Return to Entity Editor\n\n\r");

      switch (toupper(getch()))
      {
        case 'T': cputs(TYPESTRING);
                  entity->type = getint("Enter type: ", 0, NUM_TYPES); break;
        
        case '1':
          pspriteSet = getint("Enter new set: ", 0, 9);
          break;

        case '2':
          cputs("0 = DOWN, 1 = RIGHT, 2 = UP, 3 = LEFT\n\r");
          pdirection = getint("Enter direction: ", 0, 3);
          pdirection *= 3;
          break;

        case '3':
          pmapx = getint("Enter starting X: ", 0, 99);
          cputs("\n\r");
          pmapy = getint("Enter starting Y: ", 0, 99);
          break;

        case '4':
          pdelay = getint("Enter delay: ", 0, 200);
          break;

        case '5':
          cputs("0 = VERY SLOW\n\r"
                "1 = SLOW\n\r"
                "2 = NORMAL\n\r"
                "3 = EQUAL TO YOU\n\r"
                "4 = TWICE AS FAST AS YOU\n\r");
          pspeed = getint("Enter speed: ", 0, 4);
          break;

        case '6':
          pmessage = getint("Enter message number: ", 1, NUM_MESSAGES) - 1;
          break;

        case 'Q': done = 1;
      }
    }
    else if (entity->type == CHEST)

#define cspriteSet entity->data.chest.spriteSet
#define ctype      entity->data.chest.type
#define cnum       entity->data.chest.num
#define cmapx      entity->data.chest.mapx
#define cmapy      entity->data.chest.mapy

    {
      cprintf("Sprite Set: %d\n\r", cspriteSet);
      cprintf("Starting Point: (%d, %d)\n\r", cmapx, cmapy);

      char *typstr;
      if (ctype == 0) typstr = "Empty";
      if (ctype == 1) typstr = "Item";
      if (ctype == 2) typstr = "Weapon";
      if (ctype == 3) typstr = "Shield";
      if (ctype == 4) typstr = "Helmet";
      if (ctype == 5) typstr = "Mail";
      if (ctype == 6) typstr = "Gold";

      cprintf("Item type: %s\n\r", typstr);
      cprintf("Item num: %d\n\n\r", cnum + 1);

      textcolor(LIGHTMAGENTA);
      cputs("T  Change Type\n\r"
            "1  Edit Sprite Set\n\r"
            "2  Edit Starting Point\n\r"
            "3  Edit Item Type\n\r"
            "4  Edit Item Num\n\r"
            "Q  Return to Entity Editor\n\n\r");

      switch (toupper(getch()))
      {
        case 'T': cputs(TYPESTRING);
                  entity->type = getint("Enter type: ", 0, NUM_TYPES); break;
        
        case '1':
          cspriteSet = getint("Enter new set: ", 0, 127);
          break;

        case '2':
          cmapx = getint("Enter x coordinate: ", 0, 99);
          cputs("\n\r");
          cmapy = getint("Enter y coordinate: ", 0, 99);
          break;

        case '3':
          cputs("0 = Empty, 1 = Item, 2 = Weapon, 3 = Shield, 4 = Helmet, 5 = Mail, 6 = Gold\n\r");
          ctype = getint("Enter new item type: ", 0, 6);
          break;

        case '4':
          cnum = getlong("Enter new item num: ", 0, 1000000);
          break;

        case 'Q': done = 1;
      }
    }
    else if (entity->type == INN)

#define imapx      entity->data.inn.mapx
#define imapy      entity->data.inn.mapy
#define ispriteSet entity->data.inn.spriteSet
#define iname      entity->data.inn.name
#define icost      entity->data.inn.cost

    {
      cprintf("Coordinates: (%d, %d)\n\r", imapx, imapy);
      cprintf("Sprite Set: %d\n\r", ispriteSet);
      cprintf("Name: %s\n\r", iname);
      cprintf("Cost: %d\n\n\r", icost);

      textcolor(LIGHTMAGENTA);
      cputs("T  Change Type\n\r"
            "1  Edit Coordinates\n\r"
            "2  Edit Sprite Set\n\r"
            "3  Edit Name\n\r"
            "4  Edit Cost\n\r"
            "Q  Return to main menu\n\n\r");

      switch (toupper(getch()))
      {
        case 'T':
          cputs(TYPESTRING);
          entity->type = getint("Enter new item type: ", 0, NUM_TYPES);
          break;

        case '1':
          imapx = getint("Enter X coordinate: ", 0, 99);
          cputs("\n\r");
          imapy = getint("Enter Y coordinate: ", 0, 99);
          break;

        case '2':
          ispriteSet = getint("Enter sprite set: ", 0, 127);
          break;

        case '3':
          getstring(iname, "Enter name: ", 20);
          break;

        case '4':
          icost = getint("Enter cost of inn: ", 0, 30000);
          break;

        case 'Q': done = 1; break;
      }
    }
    else if (entity->type == SHOP)

#define smapx      entity->data.shop.mapx
#define smapy      entity->data.shop.mapy
#define sspriteSet entity->data.shop.spriteSet
#define smessage   entity->data.shop.message
#define sitems     entity->data.shop.items

    {
      cprintf("Coordinates: (%d, %d)\n\r", smapx, smapy);
      cprintf("Sprite Set: %d\n\r", sspriteSet);
      cprintf("Message: (%d) %Fs\n\r", smessage + 1, messages[smessage].txt);
      for (int i = 0; i < 6; i++)
        cprintf("Item Type: %d   Number: %d\n\r",
                 sitems[i].type, sitems[i].num + 1);

      putch('\n');

      textcolor(LIGHTMAGENTA);
      cputs("T  Change Type\n\r"
            "1  Edit Coordinates\n\r"
            "2  Edit Sprite Set\n\r"
            "3  Edit Message\n\r"
            "4  Edit Item\n\r"
            "Q  Return to main menu\n\n\r");

      switch (toupper(getch()))
      {
        case 'T':
          cputs(TYPESTRING);
          entity->type = getint("Enter new item type: ", 0, NUM_TYPES);
          break;

        case '1':
          smapx = getint("Enter X coordinate: ", 0, 99);
          cputs("\n\r");
          smapy = getint("Enter Y coordinate: ", 0, 99);
          break;

        case '2':
          sspriteSet = getint("Enter sprite set: ", 0, 127);
          break;

        case '3':
          smessage = getint("Enter message: ", 0, NUM_MESSAGES) - 1;
          break;

        case '4':
          int item;
          item = getint("Enter number of item: ", 1, 6) - 1;
          cputs("\n\r0 = Blank, 1 = Item, 2 = Weapon, 3 = Shield, 4 = Helmet, 5 = Mail\n\r");
          sitems[item].type = getint("Enter item type: ", 0, 5);
          cputs("\n\r");
          sitems[item].num  = getint("Enter item number: ", 1, 12) - 1;
          break;

        case 'Q': done = 1; break;
      }
    }
    else if (entity->type == BOSS)

#define bmapx      entity->data.boss.mapx
#define bmapy      entity->data.boss.mapy
#define bspriteSet entity->data.boss.spriteSet
#define bmessage   entity->data.boss.message

    {
      cprintf("Coordinates: (%d, %d)\n\r", bmapx, bmapy);
      cprintf("Sprite Set: %d\n\r", bspriteSet);
      cprintf("Message: (%d) %Fs\n\r", bmessage + 1, messages[bmessage].txt);

      textcolor(LIGHTMAGENTA);
      cputs("T  Change Type\n\r"
            "1  Edit Coordinates\n\r"
            "2  Edit Sprite Set\n\r"
            "3  Edit Message\n\r"
            "Q  Return to main menu\n\n\r");

      switch (toupper(getch()))
      {
        case 'T':
          cputs(TYPESTRING);
          entity->type = getint("Enter new item type: ", 0, NUM_TYPES);
          break;

        case '1':
          bmapx = getint("Enter X coordinate: ", 0, 99);
          cputs("\n\r");
          bmapy = getint("Enter Y coordinate: ", 0, 99);
          break;

        case '2':
          bspriteSet = getint("Enter sprite set: ", 0, 127);
          break;

        case '3':
          bmessage = getint("Enter message number: ", 1, NUM_MESSAGES) - 1;
          break;

        case 'Q': done = 1; break;
      }
    }
  }
}

void entityEditor(void)
{
  int done = 0;
  int value;

  while (!done)
  {
    clrscr();
    textcolor(LIGHTGREEN);
    cprintf("Number of Entities: %d\n\n\r", sad[subarea].numEntities);
    textcolor(LIGHTBLUE);
    cputs("1. Change Number of Entities\n\r"
          "2. Edit Entity\n\r"
          "Q. Return to Main Menu\n\r");

    switch (toupper(getch()))
    {
      case '1':
        sad[subarea].numEntities = getint("Enter number of entities: ",
                                                  0, MAX_ENTITIES);
        break;

      case '2':
        if (sad[subarea].numEntities)
        {
          value = getint("Which entity: ", 1,
                         sad[subarea].numEntities) - 1;
          editEntity(&sad[subarea].entity[value]);
        }
        break;

      case 'Q': done = 1;
    }
  }
}

void messageEditor(void)
{
  int done = 0;
  int curMessage = 0;
  int i;

  while (!done)
  {
    clrscr();
    textcolor(RED);
    cprintf("\\/ Message %d \\/\n\r", curMessage + 1);

    textcolor(LIGHTGREEN);
    for (i = curMessage; i < curMessage + 5; i++)
    {
      cprintf("%d", messages[i].length);
      gotoxy(5, wherey());
      int x;
      for (x = 0; x < 75 && messages[i].txt[x] && x < messages[i].length; x++)
        putch(messages[i].txt[x]);
      cputs("\n\r");
    }
    cputs("\n\r");

    textcolor(YELLOW);
    cputs(">  Next Messages\n\r"
          "<  Prev Messages\n\r"
          "L  Enter Message Length\n\r"
          "E  Edit Message\n\r"
          "Q  Main menu\n\n\r");
    
    int message;

    switch (toupper(getch()))
    {
      case 0: getch(); break;

      case '>': case '.':
        if (++curMessage + 4 > NUM_MESSAGES)
          curMessage = NUM_MESSAGES - 5;
        break;

      case '<': case ',':
        if (--curMessage < 0)
          curMessage = 0;
        break;

      case 'L':
        int length;
        message = getint("Which message: ", 1, NUM_MESSAGES) - 1;
        cputs("\n\r");
        length = getint("Enter length: ", 0, MESSAGE_LENGTH);
        if (length == 0) length = -1;

        messages[message].txt_free();
        if (messages[message].txt_alloc(length) == NULL)
        {
          int y;
          for (y = 0; y < NUM_MESSAGES; y++)
            messages[message].txt_free();
          cprintf("Error: Could not allocate the message\n\r");
          exit(1);
        }
        _fmemset(messages[message].txt, 0, length + 1);
        break;

      case 'E':
        message = getint("Which message: ", 1, NUM_MESSAGES) - 1;
        cprintf("\n\rEnter message:\n\r");

        char tempstr[MESSAGE_LENGTH + 1];
        getstring(tempstr, "", messages[message].length);

        int x;
        for (x = 0; x < strlen(tempstr) + 1; x++)
          messages[message].txt[x] = tempstr[x];
        break;

      case 'Q': done = 1;
    }
  }
}

int main(void)
{
  loadSubAreaData();

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(LIGHTCYAN);
    cprintf("Subarea: %d\n\n\r", subarea + 1);
    cprintf("Map File:           %s\n\r", sad[subarea].mapFile);
    cprintf("Starting Point:     (%d, %d)\n\r", sad[subarea].startx,
                                                sad[subarea].starty);
    cprintf("Number of Exits:    %d\n\r", sad[subarea].numExits);
    cprintf("Number of Entities: %d\n\r", sad[subarea].numEntities);
    cputs("\n\r");

    textcolor(LIGHTGREEN);
    cprintf(">  Next Subarea               X  Exit Editor\n\r"
            "<  Prev Subarea               E  Entity Editor\n\r"
            "1  Change Map File            M  Map Editor\n\r"
            "2  Change Starting Point      A  Art Editor\n\r"
            "\n\r"
            "T  Message Editor\n\r"
            "S  Save\n\r"
            "Q  Quit\n\n\r");

    char execstr[129];

    switch (toupper(getch()))
    {
      case '<': case ',':
        if (--subarea == -1) subarea = NUM_SUB_AREAS - 1;
        break;

      case '>': case '.':
        if (++subarea == NUM_SUB_AREAS) subarea = 0;
        break;

      case '1':
        getstring(sad[subarea].mapFile, "Enter new map file: ", 12);
        break;

      case '2':
        sad[subarea].startx = getint("Enter starting x: ", 0, 99);
        cputs("\n\r");
        sad[subarea].starty = getint("Enter starting y: ", 0, 99);
        break;

      case 'X': exitEditor(); break;
      case 'E': entityEditor(); break;
      case 'M':
        sprintf(execstr, "editmap.exe %s %s %s %s",
                         sad[subarea].mapFile,
                         TILES_FILE,
                         "maptiles.inf",
                         PALETTE_FILE);
        system(execstr);
        break;

      case 'A':
        sprintf(execstr, "editart.exe %s %s %s",
                         TILES_FILE,
                         PALETTE_FILE,
                         "maptiles.inf");
        system(execstr);
        break;

      case 'T':
        messageEditor();
        break;

      case 'S': saveSubAreaData(); break;
      case 'Q': done = 1;
    }
  }

  textcolor(7);
  clrscr();

  int x;
  for (x = 0; x < NUM_MESSAGES; x++)
    messages[x].txt_free();

  return 0;
}
