#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

long byte;

int get_num_token(FILE *handle)
{
  int bufindex = 0;
  char buffer[80];

  char data;

  // Goes until a number
  int done = 0;
  while (!done)
  {
    data = fgetc(handle);
    byte++;

    if (data == ';')
      while (data != '\n') { data = fgetc(handle); byte++; }

    if (isdigit(data))
    {
      buffer[bufindex] = data;
      bufindex++;

      while (isdigit(data))
      {
        data = fgetc(handle);
        byte++;

        buffer[bufindex] = data;
        bufindex++;
      }

      buffer[bufindex] = 0;
      done = 1;
    }
  }

  return atoi(buffer);
}

int main(int argc, char *argv[])
{
  printf("TXT2IMG - Version 1.0\n\n");
  printf("Converts .TXT files into binary image files\n\n");

  if (argc < 3) { printf("Usage: TXT2IMG <txtfile> <imgfile>\n"); return 1; }

  FILE *read, *write;

  read = fopen(argv[1], "rb");
  if (read == NULL) { printf("Could not open %s\n", argv[1]); return 1; }

  write = fopen(argv[2], "wb");
  if (write == NULL) { fclose(read); printf("Could not open %s\n", argv[2]); return 1; }

  int xsize, ysize;
  xsize = get_num_token(read);
  ysize = get_num_token(read);

  int i;
  for (i = 0; i < xsize * ysize; i++)
    fputc(get_num_token(read), write);

  fclose(read);
  fclose(write);
}
